POJ 3126 Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
 
 
题意:n组数据,给你两个四位数的素数p1,p2。将p1这个四位数每次变其中的一位,并且变过的四位数必须是素数,求经过这种变换,将p1变为p2最少需要几次。
题解:很简单的bfs,直接写就行了,知道p1和p2是素数,就不可能出现Impossible的情况,所以不用考虑Impossible这种情况。
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <queue>
using namespace std;
int p1, p2, s;
int v[10005];
int d1[5] = {1, 3, 5, 7, 9};
int d2[10] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
int d3[9] = {1, 2, 3, 4, 5, 6 ,7 ,8 ,9};

struct node {
	int p;
	int step;
}pre, nex;
int is_prime(int n) {
	int m = floor(sqrt(n)+0.5);
	for(int i = 2; i <= m; i++) {
		if(n % i == 0) return 0;
	}
	return 1;
}

void bfs() {
	queue<node> q;
	pre.p = p1;
	pre.step = 0;
	v[pre.p] = 1;
	q.push(pre);
	while(!q.empty()) {
		nex = q.front();
		q.pop();
		if(nex.p == p2) {
			s = nex.step;
			return ;
		}
		for(int j = 1; j <= 4; j++) {
			if(j == 1) {
				for(int i = 0; i < 5; i++) {
					int x = (nex.p/10)*10 + d1[i];
					if(is_prime(x) && v[x] == 0) {
						pre.p = x;
						pre.step = nex.step + 1;
						v[x] = 1;
						q.push(pre);
					}
				}
			}
			else if(j == 2) {
				for(int i = 0; i < 10; i++) {
					int x = (nex.p/100)*100+nex.p%10+d2[i]*10;
					if(is_prime(x) && v[x] == 0) {
						pre.p = x;
						pre.step = nex.step + 1;
						v[x] = 1;
						q.push(pre);
					}
				}
			}
			else if(j == 3) {
				for(int i = 0; i < 10; i++) {
					int x = (nex.p/1000)*1000+nex.p%100+d2[i]*100;
					if(is_prime(x) && v[x] == 0) {
						pre.p = x;
						pre.step = nex.step + 1;
						v[x] = 1;
						q.push(pre);
					}					
				}
			}
			else {
				for(int i = 0; i < 9; i++) {
					int x = nex.p%1000 + d3[i]*1000;
					if(is_prime(x) && v[x] == 0) {
						pre.p = x;
						pre.step = nex.step + 1;
						v[x] = 1;
						q.push(pre);
					}
				}
			}
		}
	}
	return ;
}
int main() {
	int n;
	scanf("%d",&n);
	while(n--) {
		scanf("%d%d",&p1,&p2);
		memset(v, 0, sizeof(v));
		if(p1 == p2) {
			printf("0\n");
			continue;
		}
		bfs();
		printf("%d\n",s);
	}
	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值